groovy.transform

## Annotation Type CompileStatic

-     @Documented
       @Retention(value=SOURCE)
       @Target(value={METHOD,TYPE,CONSTRUCTOR})
      public @interface CompileStatic

  This will let the Groovy compiler use compile time checks in the style of Java then perform static compilation, thus bypassing the Groovy meta object protocol.

  When a class is annotated, all methods, properties, files, inner classes, etc. of the annotated class will be type checked. When a method is annotated, static compilation applies only to items (closures and anonymous inner classes) within the method.

  By using `TypeCheckingMode.SKIP`, static compilation can be skipped on an element within a class or method otherwise marked with CompileStatic. For example a class can be annotated with CompileStatic, and a method within can be marked to skip static checking to use dynamic language features.

  See Also:
    `CompileDynamic`

- - ### Optional Element Summary

    Optional Elements
    Modifier and Type | Optional Element and Description
    --- | ---
    `java.lang.String[]` | `extensions` The list of (classpath resources) paths to type checking DSL scripts, also known as type checking extensions.
    `TypeCheckingMode` | `value`

- - ### Element Detail

    - #### value

          public abstract TypeCheckingMode value

      Default:
        groovy.transform.TypeCheckingMode.PASS

  - - #### extensions

          public abstract java.lang.String[] extensions

      The list of (classpath resources) paths to type checking DSL scripts, also known as type checking extensions.
      Returns:
        an array of paths to groovy scripts that must be on compile classpath
      Default:
        {}